const int pwm_dcho = 11; //pines y variables motor y encoder derecho 
const int IN3 = 12;
const int IN4 = 13;
int encoder_dcho = 3;     
unsigned int rpm_dcho = 0;
float vel_dcho = 0; //en Km/h
volatile byte pulsos_leidos = 0; // Número de pulsos leidos en un segundo
unsigned long tiempo_anterior = 0;  // Tiempo 
unsigned int muescas = 20; //número de muescas del disco del encoder.
const int diametro_rueda = 75; //Diámetro de las ruedas en mm
static volatile unsigned long debounce = 0; //Tiempo del rebote.
void setup(){
  pinMode(pwm_dcho,OUTPUT);
  pinMode(IN3,OUTPUT); 
  pinMode(IN4,OUTPUT);
  Serial.begin(9600); 
  pinMode(encoder_dcho, INPUT);
  attachInterrupt(1, contador, RISING); //Configuración de la interrupción 1
  pulsos_leidos = 0;
  rpm_dcho = 0;
  tiempo_anterior = 0;
  Serial.println("MOTOR DERECHO:");
  Serial.print("Segundos - ");
  Serial.print("RPM - ");
  Serial.print("Pulsos leidos - ");
  Serial.println("Velocidad (Km/h)");
  Serial.println("========   ===   =============   ================");
}
 void loop(){
  if (millis() - tiempo_anterior >= 1000){  //Se actualiza cada segundo
    noInterrupts(); // Desconectamos la interrupción para que no actué en esta parte del programa.
    digitalWrite(IN3,HIGH);
    digitalWrite(IN4,LOW);
    analogWrite(pwm_dcho,255); //a máxima velocidad
    rpm_dcho = (60 * 1000 / muescas )/ (millis() - tiempo_anterior)* pulsos_leidos; //Cálculo de las revoluciones por minuto
    vel_dcho = rpm_dcho * 3.1416 * diametro_rueda * 60 / 1000000; //Cálculo de la vel_dcho en Km/h 
    tiempo_anterior = millis(); //Almacenamos el tiempo actual.
    Serial.print("   "); Serial.print(millis()/1000); Serial.print("       ");
    Serial.print(rpm_dcho,DEC); Serial.print("       ");
    Serial.print(pulsos_leidos,DEC); Serial.print("               ");
    Serial.println(vel_dcho,2); 
    pulsos_leidos = 0;  //Inicializamos los pulsos
    interrupts(); //Reiniciamos la interrupción
  }
}
//La función contador se encarga de contar los pulsos buenos
void contador(){
  if(digitalRead(encoder_dcho) && (micros()-debounce > 500) && digitalRead (encoder_dcho)){ 
    debounce = micros(); //para comprobar que no contamos rebotes 
    pulsos_leidos++;}  //Cuen ta el pulso como bueno
} 
